const express = require('express');
const router = express.Router();
const authorize = require('../../../../middlewares/authorize-sapps');
const bloodPressureService = require('./bloodPressure.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.put('/enabled/:id', authorize(), enabled);
router.delete('/:id', authorize(), _delete);

module.exports = router;

/**
 * Create a new bloodPressure
 * @param {Object} req.body - The bloodPressure data
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the created bloodPressure
 */
function create(req, res, next) {
    bloodPressureService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get a list of all bloodPressures
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of bloodPressures
 */
function getAll(req, res, next) {
    bloodPressureService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get an array of bloodPressure objects to be used as options in a select box
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of bloodPressure objects
 */
function option(req, res, next) {
    bloodPressureService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Count the number of bloodPressures matching a query
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the count of bloodPressures
 */
function count(req, res, next) {
    bloodPressureService.count(req.query)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Update an existing bloodPressure
 * @param {number} req.params.id - The bloodPressure ID to be updated
 * @param {Object} req.body - The bloodPressure data to be updated
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the updated bloodPressure
 */
function update(req, res, next) {
    bloodPressureService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Enable or disable a bloodPressure
 * @param {number} req.params.id - The bloodPressure ID to be enabled/disabled
 * @param {Object} req.body - The bloodPressure data to be updated
 * @param {boolean} req.body.enabled - The enabled status of the bloodPressure
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the enable/disable process
 */
function enabled(req, res, next) {
    bloodPressureService.enabled(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Delete a bloodPressure
 * @param {number} req.params.id - The bloodPressure ID to be deleted
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the deletion process
 */
function _delete(req, res, next) {
    bloodPressureService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
